*******************************************************************
****    HW-5400 CONTROLLER SOFTWARE
****
****    FILE: HAM.ASM 10/26/95
****    working version
****    11/11/03 MODIFIED HAM7.ASM
****
*******************************************************************
$BASE           10T
$INCLUDE        "MEMREG.ASM"


*------------------------------------------------------------------
*       TIMER Set Points
*------------------------------------------------------------------
TIMER_1MS       EQU     56                              ; VALUE SET TO 1MS


*------------------------------------------------------------------
*       Internal Registers      ($0 to $3F)
*       1)      PortA   $00
*       2)      PortB   $04
*       3)      PortC   $03
*       4)      PortD   $08
*------------------------------------------------------------------
PLL_UNLOCK      EQU     1                               ; 27 PA0 I
TUNE_2          EQU     2                               ; 26 PA1 I
TX_REQ          EQU     4                               ; 25 PA2 I
MUTE_OUT        EQU     8                               ; 24 PA3 O
TX_OUT          EQU     32                              ; 23 PA5 O
TUNE_1          EQU     128                             ; 22 PA7 I

SCAN_OUT_0      EQU     1                               ; 35 PB0 O
SCAN_OUT_1      EQU     2                               ; 34 PB1 O
SCAN_OUT_2      EQU     4                               ; 33 PB2 O
SCAN_OUT_3      EQU     8                               ; 32 PB3 O
SEG_d           EQU     16                              ; 31 PB4 O
SEG_e           EQU     32                              ; 30 PB5 O
SEG_f           EQU     64                              ; 29 PB6 O
SEG_g           EQU     128                             ; 28 PB7 O

PLL_DATA_0      EQU     1                               ; 2  PC0 O
PLL_DATA_1      EQU     2                               ; 3  PC1 O
PLL_DATA_2      EQU     4                               ; 4  PC2 O
PLL_DATA_3      EQU     8                               ; 5  PC3 O
PLL_ADD_0       EQU     16                              ; 6  PC4 O SEG_a
PLL_ADD_1       EQU     32                              ; 7  PC5 O SEG_b
PLL_ADD_2       EQU     64                              ; 8  PC6 O SEG_c
STROBE_1        EQU     128                             ; 9  PC7 O

SCAN_IN_0       EQU     1                               ; 15 PD0 I
SCAN_IN_1       EQU     2                               ; 16 PD1 I
SCAN_IN_2       EQU     4                               ; 17 PD2 I
SCAN_IN_3       EQU     8                               ; 18 PD3 I
MODE_SEL_0      EQU     16                              ; 19 PD4 O
MODE_SEL_1      EQU     32                              ; 20 PD5 O
STROBE_2        EQU     64                              ; 16 PD6 O
NC              EQU     128                             ;    PD7 I

*------------------------------------------------------------------
*       Internal Ram Definitions ($40 to $7F) ($80 - $9F FREQ) ($A0 - $FF STACK)
*------------------------------------------------------------------
ABC_1           EQU     $40                             ; TEMPORARY REGISTER
DEFG_2          EQU     $41                             ; TEMPORARY REGISTER
COUNT_10        EQU     $42                             ; SCAN OUT COUNTER
PLL_N           EQU     $43                             ;
MEM_INDEX       EQU     $44                             ; POINTER TO FREQ MEM (MEM_1)

SYMBOL_1        EQU     $45                             ; 1 DIGIT ON DISPLAY
SYMBOL_2        EQU     $46                             ; 2ND DIGIT
MHZ_10          EQU     $47                             ; 3RD DIGIT
MHZ_1           EQU     $48                             ; 4TH DIGIT
KHZ_100         EQU     $49                             ; 5TH DIGIT
KHZ_10          EQU     $4A                             ; 6TH DIGIT
KHZ_1           EQU     $4B                             ; 7TH DIGIT
HZ_100          EQU     $4C                             ; 8TH DIGIT
HZ_10           EQU     $4D                             ; 9TH DIGIT

U712_0          EQU     $4F                             ; E1 LOOP 2
U712_1          EQU     $50

U703_0          EQU     $53                             ; D1 LOOP 1
U703_1          EQU     $54
U703_2          EQU     $55

B_REG           EQU     $57                             ; B LOOP 3

BITREG          EQU     $58
FAST            EQU     1                               ; 1=FAST (1KHZ) 0=SLOW (50HZ)
CY_OVER         EQU     2                               ; 1=CARRY OCCURED
SWAP            EQU     4                               ; 1=SWAP DONE
MANUAL          EQU     8                               ; 1=KEYPAD ENTRY ON
KEY_1           EQU     16                              ; 1=KEY PUSHED 0=RELEASED
KEY_2           EQU     32
KEY_3           EQU     64
KEY_OFF         EQU     128                             ; 1=END OF MANUAL INPUT, WAIT FOR KEY RELEASE

TUNE_3          EQU     $59                             ; TEMP REGISTER FOR TUNING ROUTINE
SWAP_4          EQU     $5A                             ; TEMP REGISTER TO SWAP MEMORIES
READ_1          EQU     $5B                             ; SCAN IN VALUE
TEMP_1          EQU     $5C
READ_2          EQU     $5D                             ; SCAN IN VALUE COMPARE REG.
KEY_COUNT       EQU     $5F                             ; KEY ENTRY POSITION
KEY_TEMP        EQU     $60                             ; TEMP REGISTER

BITREG_1        EQU     $61                             ;
UPDATE_PLL      EQU     1                               ; 1=UPDATE PLL, 0=NO UPDATE NEEDED
U705            EQU     2                               ; 1=NEED TO UPDATE BAND CHANGE
SPLIT           EQU     4                               ; 1=SPLIT MODE ON, 0=NORMAL
SPLIT1          EQU     8                               ; 1=SPLIT BUTTON HELD DOWN
SPLIT2          EQU     16                              ; 1=SPLIT SWAP ACTIVE (IN TRANSMIT)
SPLIT3          EQU     32                              ; 1=SPLIT SWAP ACTIVE (IN RECEIVE)
TXON            EQU     64                              ; FILTERED 1=TX ON 0=RECEIVE

D1              EQU     $62
D2              EQU     $63
E1              EQU     $64
E2              EQU     $65

MEMORY_1        EQU     $66                             ; CORRECT VALUE INDICATES VALUES IN RAM STILL DONT OVERRIDE
MEMORY_2        EQU     $67

COUNT_20        EQU     $68                             ; PLL UNLOCK RETRY COUNTER
COUNT_30        EQU     $69                             ; TRANSMIT COUNTER FILTER

;-----------------------------------------------
; BAND=80,40,30,20,17,15,12,10 (2 MEM EACH BAND)
; 0 = 50Hz,10'sMHz | 1'sMHz
; 1 = 100'sKHz | 10'sKHz
; 2 = 1'sKHz | 100'sHz
;-----------------------------------------------
MEM_1           EQU     $70                             ; 80M MAIN MEMORY
MEM_2           EQU     $71
MEM_3           EQU     $72
MEM_1A          EQU     $73                             ; 80M ALTERNATE MEMORY
MEM_2A          EQU     $74
MEM_3A          EQU     $75

MEM_1B          EQU     $76                             ; 40M MAIN MEMORY
MEM_2B          EQU     $77
MEM_3B          EQU     $78
MEM_1C          EQU     $79                             ; 40M ALTERNATE MEMORY
MEM_2C          EQU     $7A
MEM_3C          EQU     $7B


*------------------------------------------------------------------
*       Interuppts ($FFC0 to $FFFF)
*------------------------------------------------------------------
                ORG     $FFC0                           ; POINT ALL INTERUPPTS TO START OF CODE
        DW      ERROR_150                               ; FFC0 RESERVED
        DW      ERROR_150                               ; FFC2 RESERVED
        DW      ERROR_150                               ; FFC4 RESERVED
        DW      ERROR_150                               ; FFC6 RESERVED
        DW      ERROR_150                               ; FFC8 RESERVED
        DW      ERROR_150                               ; FFCA RESERVED
        DW      ERROR_150                               ; FFCB RESERVED
        DW      ERROR_150                               ; FFCE RESERVED
        DW      ERROR_150                               ; FFD0 RESERVED
        DW      ERROR_150                               ; FFD2 RESERVED
        DW      ERROR_150                               ; FFD4 RESERVED

        DW      ERROR_150                               ; FFD6 SCI SERIAL SYSTEM
        DW      ERROR_150                               ; FFD8 SPI
        DW      ERROR_150                               ; FFDA PULSE ACC. INPUT EDGE
        DW      ERROR_150                               ; FFDC PULSE ACC. OVERFLOW
        DW      ERROR_150                               ; FFDE TIMER OVERFLOW

        DW      ERROR_150                               ; FFE0 TIMER OUT 5 (PA3)
        DW      ERROR_150                               ; FFE2 TIMER OUT 4 (PA4)
        DW      ERROR_150                               ; FFE4 TIMER OUT 3 (PA5) 10mSec relay toggle
        DW      ERROR_150                               ; FFE6 TIMER OUT 2 (PA6) RX SHOULD DROP BEFORE THIS
        DW      ERROR_150                               ; FFE8 TIMER OUT 1 (PA7) EMITTER FIRE WINDOW
        DW      ERROR_150                               ; FFEA TIMER IN 3  (PA0) RX DATA IN
        DW      TUNING                                  ; FFEC TIMER IN 2  (PA1) DATA FEEDBACK
        DW      ERROR_150                               ; FFEE TIMER IN 1  (PA2) DATA FEEDBACK

        DW      ERROR_150                               ; FFF0 REAL TIME INT.
        DW      ERROR_150                               ; FFF2 IRQ INT.
        DW      ERROR_150                               ; FFF4 XIRQ INT.
        DW      ERROR_150                               ; FFF6 SOFTWARE INT.
        DW      ERROR_150                               ; FFF8 ILLEGAL OPCODE
        DW      ERROR_150                               ; FFFA COP FAILURE
        DW      ERROR_150                               ; FFFC CLK FAILURE

        DW      A_10                                    ; FFFE POWER ON RST

;========================================================================================
;       Start up Code ($F000-)
;       1) Set up stack
;       2) Set up watchdog timer
;       3) Set up ports (0=INPUT DEFAULT)
;========================================================================================
                ORG     $F000

A_10:           LDS     #$00FF                          ; MOVE STACK TO END OF RAM
                BSET    CONFIG,NOCOP                    ; TURN OFF WATCHDOG TIMER

                CLR     DDRB
                CLR     DDRC
                CLR     DDRD
                CLR     PORTB
                CLR     PORTC
                CLR     PORTD

                BSET    PORTC,STROBE_1                  ; STROBE OFF
                BSET    PORTA,TX_OUT                    ; TX OFF
                BCLR    PORTA,MUTE_OUT                  ; NO MUTE

                BSET    DDRB,%11111111                  ; SET UP PORTB OUTPUT
                BSET    DDRD,%01110000                  ; SET UP PORTD
                BSET    DDRC,%11111111                  ; SET UP PORTC TO ALL OUTPUT
                BSET    PACTL,PA3                       ; SET PA3 OUTPUT
                BCLR    PACTL,PA7                       ; SET PA7 INPUT

                BCLR    TCTL2,EDG2B                     ; CAPTURE TUNING ON RISING EDGE
                BSET    TCTL2,EDG2A

                CLI                                     ; ENABLE INTERUPPT SYSTEM

                LDAA    MEMORY_1
                CMPA    #$55
                BNE     CLEAR_MEM

                LDAA    MEMORY_2
                CMPA    #$AA
                BEQ     BY_PASS                         ; DO NOT RESET MEMORY

CLEAR_MEM:      LDX     #$0040                          ; RESET REGISTERS TO 0
                CLRA
A_05:           STAA    0,X
                INX
                CPX     #$006F
                BNE     A_05

                LDX     #RST_MEMORY                     ; RESET INITIAL VALUES TO MEMORY
                LDY     #MEM_1
A_30:           LDAA    0,X
                STAA    0,Y
                INX
                INY
                CMPA    #$AA
                BNE     A_30

;========================================================================================
; START UP IF VALID MEMORY
;========================================================================================
BY_PASS:        BCLR    TMSK1,IC2I                      ; TURN OFF TUNING INT.
                BSET    PORTC,STROBE_1                  ; STROBE OFF
                JSR     PROG_R
                LDAA    #$55
                STAA    MEMORY_1
                LDAA    #$AA
                STAA    MEMORY_2                        ; FOR RESET PURPOSES

                BCLR    PORTA,PA3                       ; MUTE OFF

                LDAA    #0
                STAA    B_REG
                STAA    PLL_N

                LDAA    #IC2F
                STAA    TFLG1
                BSET    TMSK1,IC2I                      ; TURN ON TUNING INT.

;========================================================================================
; MAIN LOOPING PROGRAM
;========================================================================================
BEGIN_10:       JSR     CHECK                           ; UPDATE DISPLAY AND CHECK INPUTS
                                                        ; GET KEYPAD INPUT AND CONVERT DISPLAY BACK TO MEMORY
                JSR     CONVERT                         ; CONVERT MEMORY TO DISPLAY VALUES

                BRCLR   BITREG_1,UPDATE_PLL,BEGIN_15
                BCLR    TMSK1,IC2I

                JSR     PLL_UPDATE                      ; CONVERT DISPLAY VALUE INTO PLL CODES
                JSR     PROG_N                          ; UPDATE U712 & U703

                BRCLR   BITREG_1,U705,BEGIN_12
                JSR     PROG_U705                       ; UPDATE U705
                JSR     PROG_R

BEGIN_12:       BCLR    BITREG_1,UPDATE_PLL
                BCLR    BITREG_1,U705
                LDAA    #IC2F
                STAA    TFLG1
                BSET    TMSK1,IC2I

;---------------------------------
BEGIN_15:       BRSET   PORTA,PA0,BEGIN_16              ; CHECK IF PLL UNLOCKED
                LDAA    #13                             ; <
                STAA    SYMBOL_1

                INC     COUNT_20
                LDAA    COUNT_20
                CMPA    #10
                BNE     BEGIN_15A

                LDAA    #0
                STAA    B_REG
                STAA    PLL_N
                CLR     COUNT_20

BEGIN_15A:      JMP     BEGIN_30
;----------------------------------

BEGIN_16:       CLR     COUNT_20


;----------------------------------
; TRANSMIT
;----------------------------------
BEGIN_17:       BRSET   PORTA,TX_REQ,BEGIN_20B           ; JUMP IF IN RX MODE

                LDAA    COUNT_30
                CMPA    #4
                BLO     BEGIN_20A

                BCLR    BITREG_1,SPLIT3

                BRCLR   BITREG_1,SPLIT,BEGIN_17A        ; JUMP IF NOT IN SPLIT

                BRSET   BITREG_1,SPLIT2,BEGIN_17A       ; SWAP MEMORY ONLY 1 TIME DURING TRANSMIT

                BSET    BITREG_1,SPLIT2

                JSR     SWAPOUT                         ; SWAP MAIN / ALT MEMORY
                JMP     BEGIN_25

BEGIN_17A:      BSET    BITREG_1,TXON
                BCLR    PORTA,TX_OUT                    ; TRANSMIT

                JMP     BEGIN_25

;----------------------------------
; RECEIVE
;----------------------------------
BEGIN_20A:      INC     COUNT_30
                JMP     BEGIN_20

BEGIN_20B:      CLR     COUNT_30

BEGIN_20:       BSET    PORTA,TX_OUT                    ; RX MODE (RECEIVE)
                BCLR    BITREG_1,TXON

                BCLR    BITREG_1,SPLIT2

                BRCLR   BITREG_1,SPLIT,BEGIN_25         ; JUMP IF NOT IN SPLIT

                BRSET   BITREG_1,SPLIT3,BEGIN_25        ; SWAP MEMORY ONLY 1 TIME DURING TRANSMIT

                BSET    BITREG_1,SPLIT3

                JSR     SWAPOUT

;--------------------------------------
BEGIN_25:       BRCLR   BITREG_1,SPLIT,BEGIN_26
                LDAA    #15
                STAA    SYMBOL_1                        ; - SPLIT SYMBOL
                JMP     BEGIN_30


BEGIN_26:       LDAA    #19
                STAA    SYMBOL_1                        ; NO SYMBOL FOR 1ST DIGIT


BEGIN_30:       JMP     BEGIN_10




;========================================================================================
; CONVERT FREQ TO PLL DATA
;========================================================================================
PLL_UPDATE:     LDAA    MHZ_10
                LDAB    #10
                MUL                                     ; TENS PLACE

                ADDB    MHZ_1
                LDAA    #2
                MUL                                     ; HOW MANY 500 KHZ SEGMENTS ?

                LDAA    KHZ_100
                CMPA    #5
                BLO     PLL_10
                INCB

PLL_10:         SUBB    PLL_N

                BCLR    BITREG_1,U705
                CMPB    B_REG
                BEQ     PLL_20                         ; IF B_REG VALUE DIDNT CHANGE, DONT UPDATE
                STAB    B_REG
                BSET    BITREG_1,U705                   ; NEEDS UPDATE


;----------------------
; D1 = U703 VALUE LOOP 1
;----------------------
PLL_20:         LDAA    KHZ_1
                LDAB    #20
                MUL
                STD     D1                              ; B=20(KHZ_1)

                LDAA    HZ_100
                LDAB    #10
                MUL
                ADDB    HZ_10
                CLRA
                LDX     #5
                IDIV
                XGDX                                    ; D=(10(HZ_100)+HZ_50)/5
                ADDD    D1
                STD     D1                              ; D1=D1+D
                STD     E1

                LDX     #$0613
                LDAA    KHZ_100
                CMPA    #5
                BLO     PLL_30                          ; IF KHZ100 >=5 THEN KHZ100-5
                SUBA    #5

PLL_30:         LDAB    #10
                MUL
                ADDB    KHZ_10
                ABX                                     ; X = 1555 + 10(KHZ100) + KHZ10
                XGDX                                    ; D = X
                SUBD    D1                              ; D = X - D1
                STD     D1

                ANDB    #15
                STAB    U703_0                          ; 0

                ANDA    #15
                ADDA    #32
                STAA    U703_2                          ; 32

                LDD     D1
                LSRB
                LSRB
                LSRB
                LSRB
                ADDB    #16
                STAB    U703_1                          ; 16


;-----------------------------
; E1= U712 VALUE LOOP 2
;-----------------------------
                LDD     #$03E8
                SUBD    E1
                STD     E1                              ; E1=1000-E1

                ANDB    #15
                STAB    U712_0                          ; 0

                LDD     E1
                LSRB
                LSRB
                LSRB
                LSRB
                ADDB    #16
                STAB    U712_1                          ; 16


                RTS
;========================================================================================
; DISPLAY DIGITS AND CHECK FRONT PANEL INPUTS
;========================================================================================
CHECK:          CLR     COUNT_10                        ; START CHECK AT 0

CHECK_15:       LDX     #HZ_10                          ; LOCATE FIRST DIGIT TO DISPLAY
                LDAA    COUNT_10

CHECK_17:       CMPA    #0                              ; start with hz_10 and work back to symbol_1
                BEQ     CHECK_17A
                DECA
                DEX
                JMP     CHECK_17

;------------------
CHECK_17A:      LDAA    0,X                             ; GET VALUE STORED IN DISPLAY REGISTERS
                BNE     CHECK_17G

                LDAB    COUNT_10
                CMPB    #06                             ; IF LEADING (LEFT) DIGIT IS 0 THEN SKIP
                BNE     CHECK_17G
                LDAA    #19                             ; BLANK CHARACTER

CHECK_17G:      LDX     #DISPLAY                        ; FIND PATTERN
                LDAB    #2
                MUL
                ABX

                LDAA    0,X                             ; GET SEGMENT PATTERNS FOR DIGIT
                STAA    ABC_1
                INX
                LDAA    0,X
                STAA    DEFG_2

;-----------------------------------------
                INC     COUNT_10

                LDAA    ABC_1
                ORAA    #128
                STAA    PORTC                           ; SET SEGMENT a,b,c

                LDAA    DEFG_2
                ANDA    #240                            ; USE ONLY UPPER 4 BITS
                ORAA    COUNT_10                        ; SET SCAN OUT ITEM WHICH TURNS ON DIGIT
                STAA    PORTB                           ; SEGMENTS d,e,f,g

                CLRB

CHECK_17B:      LDAA    PORTD
                ANDA    #15                             ; GET LOWER 4 BITS ONLY
                STAA    READ_1                          ; GET SCAN IN VALUE
                CMPA    READ_2
                BEQ     CHECK_17D
                STAA    READ_2
                CLRB
                JMP     CHECK_17B
CHECK_17D:      INCB
                CMPB    #15                             ; SCANNED IN VALUE MUST BE STABLE
                BNE     CHECK_17B


;*****************************************************************
;       CHECK BAND (80,40,30,20,17,15,12,10) (SCAN OUT 1)
;*****************************************************************
                LDAA    COUNT_10
                CMPA    #1
                BNE     CHECK_20

                LDX     #BAND
                LDAA    READ_1
CHECK_45:       CMPA    #0
                BEQ     CHECK_41
                DECA
                INX
                INX
                JMP     CHECK_45

CHECK_41:       LDAA   0,X                              ; GET BAND /N NUMBER
                CMPA   PLL_N
                BEQ    CHECK_41A
                STAA   PLL_N
                BSET   BITREG_1,UPDATE_PLL

CHECK_41A:      INX
                LDAA   0,X
                STAA   MEM_INDEX                        ; GET MEMORY INDEX BY BAND POSITION
                JMP    CHECK_END

;*****************************************************************
;       CHECK MODE (CW-W,CW-N,USB,LSB) (SCAN OUT 2)
;*****************************************************************
CHECK_20:       CMPA    #2                              ; CHECK MODE
                BNE     CHECK_30

                LDAA    PORTD
                ANDA    #207                            ; STRIP MODE BITS FOR PORTD
                STAA    TEMP_1

                LDAA    READ_1
                CMPA    #11
                BNE     CHECK_21
                LDAA    TEMP_1                          ; CW-WIDE 0 0
                STAA    PORTD
                LDAA    #10
                STAA    SYMBOL_2
                BRCLR   BITREG_1,TXON,CHECK_20A
                LDAA    #16
                STAA    SYMBOL_2                        ; TRANSMIT WITH CW
CHECK_20A:      JMP     CHECK_END

CHECK_21:       CMPA    #12
                BNE     CHECK_22
                LDAA    TEMP_1
                ORAA    #32                             ; CW-NARROW 0 1
                STAA    PORTD
                LDAA    #10
                STAA    SYMBOL_2
                BRCLR   BITREG_1,TXON,CHECK_21A
                LDAA    #16
                STAA    SYMBOL_2                        ; TRANSMIT WITH CW
CHECK_21A:      JMP     CHECK_END

CHECK_22:       CMPA    #13
                BNE     CHECK_24
                LDAA    MEM_INDEX                       ; NORM (LSB 80,40) (USB 30,20,17,15,12,10)
                CMPA    #4                              ; CHECK IF < OR > 10 MHZ
                BHS     CHECK_23

CHECK_23A:      LDAA    TEMP_1
                ORAA    #48                             ; USB ABOVE 10MHZ
                STAA    PORTD
                LDAA    #11
                STAA    SYMBOL_2
                BRCLR   BITREG_1,TXON,CHECK_23B
                LDAA    #17
                STAA    SYMBOL_2                        ; TRANSMIT WITH USB
CHECK_23B:      JMP     CHECK_END

CHECK_23:       LDAA    TEMP_1
                ORAA    #16                             ; LSB BELOW 10MHZ 10
                STAA    PORTD
                LDAA    #12
                STAA    SYMBOL_2
                BRCLR   BITREG_1,TXON,CHECK_23C
                LDAA    #18
                STAA    SYMBOL_2                        ; TRANSMIT WITH LSB
CHECK_23C:      JMP     CHECK_END

CHECK_24:       LDAA    MEM_INDEX                       ; REV (USB 80,40) (LSB 30,20,17,15,12,10)
                CMPA    #4                              ; CHECK IF < OR > 10 MHZ
                BLO     CHECK_23                        ; JMP TO USB IF < 10MHZ
                JMP     CHECK_23A                       ; JMP TO LSB IF > 10MHZ


;*****************************************************************
;       CHECK SWITCHES  (SCAN OUT 3)
;*****************************************************************
CHECK_30:       CMPA    #3
                BEQ     CHECK_31A
                JMP     CHECK_40

CHECK_31A:      LDAA    READ_1
                CMPA    #13                             ; D <> M
                BNE     CHECK_31

                BRSET   BITREG,SWAP,CHECK_31            ; SWAP ONLY 1 TIME

                JSR     SWAPOUT

                BSET    BITREG,SWAP

;---------------------------
CHECK_31:       CMPA    #14                             ; D > M PUSHED
                BNE     CHECK_32

                LDX     #MEM_1
                LDAB    MEM_INDEX
                LDAA    #3
                MUL
                ABX

                LDAA    0,X                             ; COPY MAIN MEM INTO ALTERNATE MEM
                STAA    3,X

                LDAA    1,X
                STAA    4,X

                LDAA    2,X
                STAA    5,X
                JMP     CHECK_34

;----------------------------
CHECK_32:       CMPA    #11                             ; SPLIT PUSHED
                BNE     CHECK_33

                BRSET   BITREG_1,SPLIT1,CHECK_34
                BRSET   BITREG_1,SPLIT,CHECK_32A

                BSET    BITREG_1,SPLIT                  ; TOGGLE SPLIT ON
                BSET    BITREG_1,SPLIT3
                BCLR    BITREG_1,SPLIT2

                BSET    BITREG_1,SPLIT1
                JMP     CHECK_34

CHECK_32A:      BCLR    BITREG_1,SPLIT                  ; TOGGLE SPLIT OFF
                BSET    BITREG_1,SPLIT1

;-----------------------------
CHECK_33:       CMPA    #15                             ; NO KEY PRESSED
                BNE     CHECK_34

                BCLR    BITREG,SWAP                     ; DONT ALLOW NEW SWAP UNTIL KEY RELEASED
                BCLR    BITREG_1,SPLIT1                 ; SPLIT RELEASED

CHECK_34:       JMP     CHECK_END

;*****************************************************************
;       CHECK FAST/SLOW TUNING SPEED (SCAN OUT 4)
;*****************************************************************
CHECK_40:       CMPA    #4
                BNE     CHECK_50

                BCLR    BITREG,FAST
                LDAA    READ_1
                CMPA    #14
                BNE     CHECK_40A
                BSET    BITREG,FAST                     ; SET FAST TUNING

CHECK_40A:      JMP     CHECK_END

;*****************************************************************
;       CHECK V KEYPAD (ENT=7,0=13,5=14) (SCAN OUT 5)
;*****************************************************************
CHECK_50:       CMPA    #5
                BNE     CHECK_60

                LDAA    READ_1
                CMPA    #7
                BNE     CHECK_151

                BRSET   BITREG,MANUAL,CHECK_151A
                CLR     KEY_COUNT
                LDX     #MHZ_10
                LDAA    0,X
                STAA    KEY_TEMP
                LDAA    #14
                STAA    0,X
                BSET    BITREG,MANUAL
                BSET    BITREG,KEY_1
                JMP     CHECK_153A

CHECK_151A:     BRSET   BITREG,KEY_1,CHECK_153A
                BSET    BITREG,KEY_1
                LDAA    #14
                JMP     CHECK_KEY

CHECK_151:      BRCLR   BITREG,MANUAL,CHECK_153

                CMPA    #13
                BNE     CHECK_152
                BRSET   BITREG,KEY_1,CHECK_153A
                BSET    BITREG,KEY_1
                LDAA    #0
                JMP     CHECK_KEY

CHECK_152:      CMPA    #14
                BNE     CHECK_153
                BRSET   BITREG,KEY_1,CHECK_153A
                BSET    BITREG,KEY_1
                LDAA    #5
                JMP     CHECK_KEY

CHECK_153:      BCLR    BITREG,KEY_1
                BRCLR   BITREG,KEY_OFF,CHECK_153A
                BCLR    BITREG,KEY_OFF
                BCLR    BITREG,MANUAL
                BSET    BITREG_1,UPDATE_PLL
                JSR     DIS_TO_MEM

CHECK_153A:     JMP     CHECK_END

;*****************************************************************
;       CHECK U KEYPAD (6=7,1=11,2=13,7=14) (SCAN OUT 6)
;*****************************************************************
CHECK_60:       CMPA    #6
                BNE     CHECK_70
                BRCLR   BITREG,MANUAL,CHECK_164

                LDAA    READ_1
                CMPA    #7
                BNE     CHECK_161
                BRSET   BITREG,KEY_2,CHECK_164A
                BSET    BITREG,KEY_2
                LDAA    #6
                JMP     CHECK_KEY

CHECK_161:      CMPA    #11
                BNE     CHECK_162
                BRSET   BITREG,KEY_2,CHECK_164A
                BSET    BITREG,KEY_2
                LDAA    #1
                JMP     CHECK_KEY

CHECK_162:      CMPA    #13
                BNE     CHECK_163
                BRSET   BITREG,KEY_2,CHECK_164A
                BSET    BITREG,KEY_2
                LDAA    #2
                JMP     CHECK_KEY

CHECK_163:      CMPA    #14
                BNE     CHECK_164
                BRSET   BITREG,KEY_2,CHECK_164A
                BSET    BITREG,KEY_2
                LDAA    #7
                JMP     CHECK_KEY

CHECK_164:      BCLR    BITREG,KEY_2
CHECK_164A:     JMP     CHECK_END

;*****************************************************************
;       CHECK R KEYPAD (8=7,3=11,4=13,9=14) (SCAN OUT 7)
;*****************************************************************
CHECK_70:       CMPA    #7
                BNE     CHECK_END

                BRCLR   BITREG,MANUAL,CHECK_175

                LDAA    READ_1
                CMPA    #7
                BNE     CHECK_172
                BRSET   BITREG,KEY_3,CHECK_175A
                BSET    BITREG,KEY_3
                LDAA    #8
                JMP     CHECK_KEY

CHECK_172:      CMPA    #11
                BNE     CHECK_173
                BRSET   BITREG,KEY_3,CHECK_175A
                BSET    BITREG,KEY_3
                LDAA    #3
                JMP     CHECK_KEY

CHECK_173:      CMPA    #13
                BNE     CHECK_174
                BRSET   BITREG,KEY_3,CHECK_175A
                BSET    BITREG,KEY_3
                LDAA    #4
                JMP     CHECK_KEY

CHECK_174:      CMPA    #14
                BNE     CHECK_175
                BRSET   BITREG,KEY_3,CHECK_175A
                BSET    BITREG,KEY_3
                LDAA    #9
                JMP     CHECK_KEY

CHECK_175:      BCLR    BITREG,KEY_3
CHECK_175A:     JMP     CHECK_END






;========================================================================================
; DISPLAY KEYPAD INPUTS
;========================================================================================
CHECK_KEY:      BRSET   BITREG,KEY_OFF,CHECK_KEY30

                LDX     #MHZ_10
                LDAB    KEY_COUNT
                ABX
                CMPA    #14
                BNE     CHECK_KEY10

                LDAB    KEY_TEMP                        ; IF ENT HIT AGAIN, REPLACE ORIGINAL VALUE BACK
                STAB    0,X
                JMP     CHECK_KEY20

CHECK_KEY10:    STAA    0,X                             ; STORE NEW VALUE IN CURRENT LOCATION

CHECK_KEY20:    INC     KEY_COUNT                       ; GO TO NEXT LOCATION
                LDAA    KEY_COUNT
                CMPA    #7
                BEQ     CHECK_KEY30

                INX
                LDAA    0,X
                STAA    KEY_TEMP                        ; SAVE NEXT POSITION VALUE

                LDAA    #14
                STAA    0,X                             ; PLACE UNDERSCORE
                JMP     CHECK_END

CHECK_KEY30:    BSET    BITREG,KEY_OFF


CHECK_END:      JSR     DELAY_1MS
                LDAA    COUNT_10                        ; CHECK FOR END OF SCAN (10)
                CMPA    #9
                BEQ     CHECK_END1
                JMP     CHECK_15

CHECK_END1:     CLR     PORTB                           ; TURN OFF DIGIT
                RTS

*--------------------
* DELAY 1MS
*--------------------
DELAY_1MS:      PSHA
                CLRA
DELAY_10:       INCA
                NOP
                NOP
                CMPA    #TIMER_1MS
                BNE     DELAY_10

                PULA
                RTS

DELAY_LONG:     PSHX
                LDX     #$A000
DELAY_101:      DEX
                NOP
                NOP
                CPX     #0
                BNE     DELAY_101

                PULX
                RTS


*******************************************************************
* PROGRAM /R LATCHES ON ALL 3 PLL CHIPS
*******************************************************************
PROG_R:         LDX     #DIV_R

                BSET    PORTC,PC4+PC5+PC6               ; ADD=111
                NOP
                BCLR    PORTD,STROBE_2                  ; STROBE_2 LOW FOR Q=0
                NOP
                BCLR    PORTC,STROBE_1
                NOP
                BSET    PORTC,STROBE_1                  ; CLK D FLIP-FLOP (Q=0)

                LDAB    #4
PROG_05:        DECB                                    ; PROGRAM /R FOR U703
                BEQ     PROG_10
                BCLR    PORTD,STROBE_2                  ; SELECT U703
                LDAA    0,X
                STAA    TEMP_1
                JSR     PROG_DATA
                INX
                JMP     PROG_05

;-----------------------
PROG_10:        LDAB    #4
PROG_15:        DECB                                    ; PROGRAM /R FOR U712
                BEQ     PROG_20
                BSET    PORTD,STROBE_2                  ; SELECT U712
                LDAA    0,X
                STAA    TEMP_1
                JSR     PROG_DATA
                INX
                JMP     PROG_15

;----------------------
PROG_20:        BSET    PORTC,PC4+PC5+PC6               ; ADD=111
                NOP
                BSET    PORTD,STROBE_2                  ; STROBE_2 HIGH
                NOP
                BCLR    PORTC,STROBE_1
                NOP
                BSET    PORTC,STROBE_1                  ; CLK D FLIP-FLOP (Q=1)
                NOP
                BCLR    PORTD,STROBE_2                  ; TURN OFF DATA LINE

                NOP
                LDAB    #4
PROG_25:        DECB                                    ; PROGRAM /R FOR U705
                BEQ     PROG_30
                LDAA    0,X
                STAA    TEMP_1
                JSR     PROG_DATA
                INX
                JMP     PROG_25

PROG_30:        RTS


*------------------------------------------------------------------
* PROGRAM /N LATCHES ON U712 & U703 PLL'S
*------------------------------------------------------------------
PROG_N:         NOP
                BSET    PORTC,PC4+PC5+PC6               ; ADD=111
                NOP
                BCLR    PORTD,STROBE_2                  ; STROBE_2 LOW FOR Q=0
                NOP
                BCLR    PORTC,STROBE_1
                NOP
                BSET    PORTC,STROBE_1                  ; CLK D FLIP-FLOP (Q=0)

;--------------------------
; U703, D1, LOOP 1 (3REG)
;--------------------------
                LDAA    U712_0
                STAA    TEMP_1
                BCLR    PORTD,STROBE_2                  ; SELECT U703
                JSR     PROG_DATA                       ; REG 0

                LDAA    U712_1
                STAA    TEMP_1
                BCLR    PORTD,STROBE_2                  ; SELECT U703
                JSR     PROG_DATA                       ; REG 16

                LDAA    #35
                STAA    TEMP_1
                BCLR    PORTD,STROBE_2                  ; SELECT U703
                JSR     PROG_DATA                       ; REG 32

                LDAA    #48
                STAA    TEMP_1
                BCLR    PORTD,STROBE_2                  ; SELECT U703
                JSR     PROG_DATA                       ; REG 48


                LDAA    U703_0
                STAA    TEMP_1
                BSET    PORTD,STROBE_2                  ; SELECT U712
                JSR     PROG_DATA                       ; REG 0

                LDAA    U703_1
                STAA    TEMP_1
                BSET    PORTD,STROBE_2                  ; SELECT U712
                JSR     PROG_DATA                       ; REG 16

                LDAA    U703_2
                STAA    TEMP_1
                BSET    PORTD,STROBE_2                  ; SELECT U712
                JSR     PROG_DATA                       ; REG 32

                LDAA    #48
                STAA    TEMP_1
                BSET    PORTD,STROBE_2                  ; SELECT U712
                JSR     PROG_DATA                       ; REG 48


                RTS

;----------------------------------------------------------------------
; PROGRAM /N REGISTERS ON U705 PLL
;----------------------------------------------------------------------
PROG_U705:      BSET    PORTC,PC4+PC5+PC6               ; ADD=111
                NOP
                BSET    PORTD,STROBE_2                  ; STROBE_2 HIGH TO MAKE Q=1
                NOP
                BCLR    PORTC,STROBE_1
                NOP
                BSET    PORTC,STROBE_1                  ; CLK D FLIP-FLOP (Q=1)
                NOP
                BCLR    PORTD,STROBE_2                  ; TURN OFF DATA LINE

                LDAA    B_REG
                STAA    TEMP_1
                JSR     PROG_DATA                       ; REG 0

                LDAA    #16
                STAA    TEMP_1
                JSR     PROG_DATA                       ; REG 16

                LDAA    #32
                STAA    TEMP_1
                JSR     PROG_DATA                       ; REG 32

                LDAA    #48
                STAA    TEMP_1
                JSR     PROG_DATA                       ; REG 48

                RTS

;-------------------------
; PROGRAM DATA IN PLL REG
;-------------------------
PROG_DATA:      LDAA    TEMP_1
                ORAA    #128                            ; KEEP STROBE_1 HIGH
                STAA    PORTC                           ; SET PLL DATA AND ADDRESS LINES
                NOP
                BCLR    PORTC,STROBE_1                  ; PROGRAM U705
                NOP
                BSET    PORTC,STROBE_1                  ; LATCH DATA
                NOP
                BCLR    PORTD,STROBE_2                  ; DE-SELECT
                RTS


*------------------------------------------------------------------
* TUNING CONTROL
* TRIGGERED ON RISING EDGE OF PA1 (IC2I)
* INCREMENT = PA7 LOW
* DECREMENT = PA7 HIGH
*------------------------------------------------------------------
TUNING:         PSHA
                PSHB
                PSHX

                LDAA    #IC2F
                STAA    TFLG1                           ; CLEAR FLAG

                BRCLR   BITREG,MANUAL,TUNING_02
                JMP     TUNING_END

TUNING_02:      BSET    BITREG_1,UPDATE_PLL

                LDX     #MEM_1
                LDAB    MEM_INDEX
                LDAA    #3
                MUL
                ABX                                     ; X = LOCATION OF CURRENT MEMORY

                BRSET   PORTA,PA7,TUNING_10             ; JMP FOR DECREMENT

;-------------------------------
; INCREMENT
;-------------------------------
                BRCLR   BITREG,FAST,TUNING_04


                LDAA    0,X
                ANDA    #63
                STAA    0,X                             ; RESET 50 HZ BIT


                LDAA    2,X
                ANDA    #$F0                            ; CLEAR OUT 100HZ REGISTER

                ADDA    #$10                            ; INC 1KHZ STEP (FAST)

                JMP     TUNING_06


TUNING_04:      LDAA    0,X                             ; INC 50HZ STEP (SLOW)
                EORA    #64                             ; ALTERNATE BIT 6
                STAA    0,X

                ANDA    #64                             ; GET ONLY BIT 6
                BEQ     TUNING_05                       ; IF BIT CLR, THEN IT CARRIED (JMP)
                JMP     TUNING_END                      ; DONE, IF BIT NOW SET

TUNING_05:      LDAA    2,X
                ADDA    #1


TUNING_06:      DAA
                STAA    2,X
                LDAA    1,X
                ADCA    #0
                DAA
                STAA    1,X
                LDAA    0,X
                ADCA    #0
                DAA
                STAA    0,X
                JMP     TUNING_END

;--------------------------
; DECREMENT
;--------------------------
TUNING_10:      CLRB
                BRCLR   BITREG,FAST,TUNING_10B

                LDAA    0,X
                ANDA    #63
                STAA    0,X                             ; RESET 50 HZ BIT


                LDAA    2,X
                ANDA    #$F0                            ; CLEAR OUT 100HZ REGISTER

                SUBA    #$10                            ; DEC 1KHZ STEP (FAST)
                JMP     TUNING_06B

TUNING_10B:     LDAA    0,X                             ; DEC 50HZ STEP (SLOW)
                EORA    #64                             ; ALTERNATE BIT 6
                STAA    0,X

                ANDA    #64                             ; GET ONLY BIT 6
                BNE     TUNING_05A                      ; IF BIT SET, THEN IT CARRIED (JMP)
                JMP     TUNING_END                      ; DONE, IF BIT NOW CLR

TUNING_05A:     LDAA    2,X
                SUBA    #1
TUNING_06B:     STAA    2,X

                BCLR    BITREG,CY_OVER
                BCC     TUNING_05D
                LDAB    #$60
                BSET    BITREG,CY_OVER

TUNING_05D:     ANDA    #15
                CMPA    #15
                BNE     TUNING_05B
                ADDB    #06

TUNING_05B:     STAB    TUNE_3
                LDAA    2,X
                SUBA    TUNE_3
                STAA    2,X

;-----------------------------
                CLC
                CLRB
                BRCLR   BITREG,CY_OVER,TUNING_06C
                SEC

TUNING_06C:     LDAA    1,X
                SBCA    #0
                STAA    1,X

                BCLR    BITREG,CY_OVER
                BCC     TUNING_05F
                LDAB    #$60
                BSET    BITREG,CY_OVER

TUNING_05F:     ANDA    #15
                CMPA    #15
                BNE     TUNING_05G
                ADDB    #06

TUNING_05G:     STAB    TUNE_3
                LDAA    1,X
                SUBA    TUNE_3
                STAA    1,X

;-----------------------------
                CLC
                CLRB
                BRCLR   BITREG,CY_OVER,TUNING_06H
                SEC

TUNING_06H:     LDAA    0,X
                SBCA    #0
                STAA    0,X

                ANDA    #15
                CMPA    #15
                BNE     TUNING_05J
                ADDB    #06

TUNING_05J:     STAB    TUNE_3
                LDAA    0,X
                SUBA    TUNE_3
                STAA    0,X


TUNING_END:     BSET    TMSK1,IC2I
                PULX
                PULB
                PULA
                RTI

*------------------------------------------------------------------
* CONVERT CONPRESSED MEMORY INTO NUMBERS (MHZ TO HZ) (SUBROUTINE)
* INPUTS:       MEM_INDEX (# OF MEMORY)
* OUTPUTS:      MHZ TO HZ
*------------------------------------------------------------------
CONVERT:        BRCLR   BITREG,MANUAL,CONVERT_10
                RTS

CONVERT_10:     LDX     #MEM_1                           ; STARTING LOCATION OF STORAGE
                LDAB    MEM_INDEX
                LDAA    #3
                MUL
                ABX                                     ; X = LOCATION OF MEM_1

                CLR     HZ_10
                LDAA    0,X                             ; GET VALUE IN MEMORY FROM INDEX POINT
                LSLA
                LSLA
                BCC    CONVERT_30
                LDAB    #5                              ; IF MSb OF 1ST BYTE =1 THEN HZ_1 = 5
                STAB    HZ_10

CONVERT_30:     LSRA
                LSRA
                LSRA
                LSRA
                LSRA
                LSRA
                STAA    MHZ_10                          ; get 10's of MHZ

                LDAA    0,X
                ANDA    #15
                STAA    MHZ_1                           ; GET 1'S OF MHZ

                LDAA    1,X
                LSRA
                LSRA
                LSRA
                LSRA
                STAA    KHZ_100                         ; GET 100'S OF KHZ

                LDAA    1,X
                ANDA    #15
                STAA    KHZ_10                          ; GET 10'S OF KHZ

                LDAA    2,X
                LSRA
                LSRA
                LSRA
                LSRA
                STAA    KHZ_1                           ; GET 1'S OF KHZ

                LDAA    2,X
                ANDA    #15
                STAA    HZ_100                          ;GET 100' OF HZ

                RTS


*------------------------------------------------------------------
* SWAP MAIN AND ALTERNATE MEMORY
*------------------------------------------------------------------
SWAPOUT:        BSET    BITREG_1,UPDATE_PLL
                LDX     #MEM_1                          ; SWAP MAIN AND ALTERNATE MEM
                LDAB    MEM_INDEX
                LDAA    #3
                MUL
                ABX
                LDAA    0,X
                STAA    SWAP_4
                LDAA    3,X
                STAA    0,X
                LDAA    SWAP_4
                STAA    3,X

                LDAA    1,X
                STAA    SWAP_4
                LDAA    4,X
                STAA    1,X
                LDAA    SWAP_4
                STAA    4,X

                LDAA    2,X
                STAA    SWAP_4
                LDAA    5,X
                STAA    2,X
                LDAA    SWAP_4
                STAA    5,X

                RTS

*------------------------------------------------------------------
* CONVERT DISPLAY (MHZ,KHZ,HZ REG) TO MEM_1 MEM_2 MEM_3 COMPRESSED
*------------------------------------------------------------------
DIS_TO_MEM:     LDX     #MEM_1                           ; STARTING LOCATION OF STORAGE
                LDAB    MEM_INDEX
                LDAA    #3
                MUL
                ABX                                     ; X = LOCATION OF MEM_1

                LDAA    KHZ_100
                LSLA
                LSLA
                LSLA
                LSLA
                ADDA    KHZ_10
                STAA    1,X                             ; STORE MEM_2

                LDAA    KHZ_1
                LSLA
                LSLA
                LSLA
                LSLA
                ADDA    HZ_100
                STAA    2,X                             ; STORE MEM_3

                BCLR    MHZ_10,PC6

                LDAA    HZ_10
                BEQ     DIS_TO10
                LDAA    #5
                STAA    HZ_10                           ; EITHER 0 OR 5

                BSET    MHZ_10,PC6

DIS_TO10:       LDAA    MHZ_10
                LSLA
                LSLA
                LSLA
                LSLA
                ADDA    MHZ_1
                STAA    0,X                             ; STORE MEM_1

                RTS


;---------------------------------------
ERROR_150:      JMP     A_10



*------------------------------------------------------------------
* DATA
*------------------------------------------------------------------

DIV_R:          DB      97,89,64                       ; U703 1,9,0
                DB      97,89,66                       ; U712 1,9,2
                DB      96,81,68                       ; U705 0,1,4
                DB      0,0,0,0

BAND:           DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0    ; 0,1,2,3,4,5,6
                DB      51,14,45,12                   ; 10,12
                DB      33,10,31,8                    ; 15,17
                DB      25,6,11,4                     ; 20,30
                DB      11,2,3,0                      ; 40,80
                DB      0,0                           ; /N BASE ,MEMORY INDEX OFFSET (15)

DISPLAY:        ; FORMAT     SEGMENT(ABC 16,32,64),(DEFG 16,32,64,128)
                ;  A
                ;F   B
                ;  G
                ;E   C
                ;  D

                DB     112,112,96,0                   ; 0 & 1         0,1
                DB     48,176,112,144                 ; 2 & 3         2,3
                DB     96,192,80,208                  ; 4 & 5         4,5
                DB     64,240,112,0                   ; 6 & 7         6,7
                DB     112,240,112,192                ; 8 & 9         8,9
                DB     0,176,64,48,0,48               ; C & U & L     10,11,12
                DB     16,0,0,16,0,128                ; < & M & -     13,14,15
                DB     16,176,80,48,16,48             ; -C & -U & -L  16,17,18
                DB     0,0,0,0,0,0,0,0

RST_MEMORY      DB     $03,$75,$00,$03,$75,$00         ; 80 BAND
                DB     $07,$15,$00,$07,$15,$00         ; 40
                DB     $10,$00,$00,$10,$00,$00         ; 30
                DB     $14,$17,$50,$14,$17,$50         ; 20
                DB     $18,$11,$00,$18,$11,$00         ; 17
                DB     $21,$22,$50,$21,$22,$50         ; 15
                DB     $24,$93,$00,$24,$93,$00         ; 12
                DB     $28,$30,$00,$28,$30,$00         ; 10
                DB     $AA                             ; END


END
